void keyPressed() { // Gets executed every time a key is pressed

  if (key == ' ') {
    String s = name+".jpg";
    save(s);
    println("Picture Saved!");
  }

  switch (programState) {

  case 'A': // Enter Sample Name

    if (keyCode == BACKSPACE) {
      if (name.length() > 0) {
        name = name.substring(0, name.length()-1);
      }
    } else if (keyCode == DELETE) {
      name = "";
    } else if (keyCode != ENTER && keyCode != SHIFT && keyCode != CONTROL && keyCode != ALT && keyCode != BACKSPACE && keyCode != DELETE) {
      name = name + key;
    }

    break;

  case 'B': // Enter Sample Weight

    if (keyCode == BACKSPACE) {
      if (weight.length() > 0) {
        weight = weight.substring(0, weight.length()-1);
      }
    } else if (keyCode == DELETE) {
      weight = "";
    } else if (keyCode != ENTER && keyCode != SHIFT && keyCode != CONTROL && keyCode != ALT && keyCode != BACKSPACE && keyCode != DELETE) {
      weight = weight + key;
    }

    break;

  case 'E': // Enter Sample Weight

    if (keyCode == ENTER) reset();

    break;
  }
}

void mousePressed() { // Gets executed every time the mouse is pressed

  if (programState == 'E' && button(width*0.81, height*0.92, 55, "WRITE")) {

    println("row: " + results.getRowCount() + "Column: " + results.getColumnCount());

    if (saveCount == 0) { 
      results.addColumn();
      results.setString(0, results.getColumnCount()-1, name);
      results.setString(results.getRowCount()-1, results.getColumnCount()-1, weight);
    }

    float deflection = (leftDef+rightDef)/2;
    results.setFloat(saveCount+2, results.getColumnCount()-1, deflection);

    saveTable(results, "data/results.csv");
    println("Measurement Saved!" + saveCount);
    saveCount ++;
  }
}